Imports GrapeCity.ActiveReports 
Imports GrapeCity.ActiveReports.Document
Imports System.Data.OleDb
Imports System.Data

Public Class rptProjects 

    Private Sub rptProjects_ReportStart(sender As System.Object, e As System.EventArgs) Handles MyBase.ReportStart
        Dim connString As [String] = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\data.mdb;Persist Security Info=False"
        Dim rptSqlCmd As [String] = "SELECT tblProjects.ProjectName, " & "tblProjects.ProjectStart, " & "tblProjects.ProjectEnd, " & "DateDiff('d',[tblProjects]![ProjectStart],[tblProjects]![ProjectEnd]) AS Duration, " & "DateDiff('d',[StartDate],[tblProjects]![ProjectStart]) AS StartValue, " & "DateDiff('d',[StartDate],[tblProjects]![ProjectEnd]) AS EndValue " & "FROM tblProjects;"
        Dim conn As New OleDbConnection(connString)
        conn.Open()
        'The Gantt series takes two Y values: the start and end points as integers so
        'we need to compute these from the StartDate and EndDate. To do the computation
        'we need to subtract these dates from a starting date which is the 
        'minimum start date for the projects. 

        'Get the earliest project start date

        Dim cmd1 As New OleDbCommand("SELECT Min([ProjectStart]) AS MinStartDate FROM tblProjects;", conn)
        Dim minStartDate As DateTime = DirectCast(cmd1.ExecuteScalar(), DateTime)

        ' Get the latest project end date
        Dim cmd2 As New OleDbCommand("SELECT Max([ProjectEnd]) AS MaxEndDate FROM tblProjects;", conn)
        Dim maxEndDate As DateTime = DirectCast(cmd2.ExecuteScalar(), DateTime)

        ' Provide the minimum value as a parameter to the SQL statement. 
        ' The SQL Statement has calculated fields StartValue and EndValue. These columns in the
        ' DataTable will be the ValueMemembersY of the series
        Dim cmd As New OleDbCommand(rptSqlCmd, conn)
        cmd.Parameters.Add(New OleDbParameter("@StartDate", OleDbType.[Date])).Value = minStartDate
        Dim da As New OleDbDataAdapter(cmd)
        Dim dtProjects As New DataTable("Projects")
        da.Fill(dtProjects)

        ' Set the datatable as the datasource for the chart and report
        Me.DataSource = dtProjects
        SetChartControl(dtProjects, minStartDate, maxEndDate)

        conn.Close()
    End Sub
    Private Sub SetChartControl(dt As DataTable, minDate As DateTime, maxDate As DateTime)
        ' Chart Titles
        Me.chartControl1.Titles("header").Text = "Gantt Chart"
        Me.chartControl1.Titles.Remove(Me.chartControl1.Titles("footer"))

        ' ValueMember
        Me.chartControl1.Series("Series1").ValueMemberX = "ProjectName"
        Me.chartControl1.Series("Series1").ValueMembersY = "StartValue, EndValue"

        ' AxisX properties
        Me.chartControl1.ChartAreas(0).Axes("AxisX").Title = "Projects"
        Me.chartControl1.ChartAreas(0).Axes("AxisX").TitleFont.Angle = -90


        ' AxisY properties
        Dim axisY As GrapeCity.ActiveReports.Chart.AxisBase = Me.chartControl1.ChartAreas(0).Axes("AxisY")

        ' Use the min and max dates to add labels to the y-axis
        Dim labelCount As Integer = 0
        Dim counter As DateTime = minDate
        While counter <= maxDate
            labelCount += 1
            axisY.Labels.Add(counter.ToShortDateString())
            counter = counter.AddDays(1)
        End While

        axisY.Min = 0
        axisY.Max = labelCount - 1
        axisY.MajorTick.[Step] = 1
        axisY.MajorTick.Visible = True
        axisY.LabelsVisible = True
        axisY.MajorTick.Visible = True
        axisY.MajorTick.GridLine = New GrapeCity.ActiveReports.Chart.Graphics.Line(Color.Gray, 1, GrapeCity.ActiveReports.Chart.Graphics.LineStyle.Solid)
        axisY.LabelFont.Angle = -45
        axisY.TitleFont.Angle = 0
        axisY.SmartLabels = False
        axisY.Title = ""

        ' Set the Chartcontrol Data Source
        Me.chartControl1.DataSource = dt
    End Sub
End Class
